package tech.nevets.vplus.blocks;

import net.minecraft.block.*;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.particle.ParticleTypes;
import net.minecraft.sound.BlockSoundGroup;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;
import tech.nevets.vplus.items.VPItemGroups;

import static tech.nevets.vplus.Main.modid;

public class VPBlocks {

    public static final Block LAVASPONGEBLOCK = new LavaSpongeBlock();
    public static final Block SATURATEDLAVASPONGEBLOCK = new SaturatedLavaSpongeBlock();
    public static final Block PLATINUMORE = new PlatinumOre();
    public static final Block PLATINUMBLOCK = new PlatinumBlock();
    public static final Block RUBYBLOCK = new RubyBlock();
    public static final Block RUBYORE = new RubyOre();

    public static void vpBlocks() {
        initializeBlocks();
        initializeBlockItems();
        initializeTorches();
        VPVerticalSlabs.vpVerticalSlabs();
    }

    public static void initializeBlocks() {
        Registry.register(Registry.BLOCK, new Identifier(modid, "lava_sponge"), LAVASPONGEBLOCK);
        Registry.register(Registry.BLOCK, new Identifier(modid, "saturated_lava_sponge"), SATURATEDLAVASPONGEBLOCK);
        Registry.register(Registry.BLOCK, new Identifier(modid, "platinum_ore"), PLATINUMORE);
        Registry.register(Registry.BLOCK, new Identifier(modid, "platinum_block"), PLATINUMBLOCK);
        Registry.register(Registry.BLOCK, new Identifier(modid, "ruby_block"), RUBYBLOCK);
        Registry.register(Registry.BLOCK, new Identifier(modid, "ruby_ore"), RUBYORE);
    }

    public static void initializeBlockItems() {
        Registry.register(Registry.ITEM, new Identifier(modid, "lava_sponge"), new BlockItem(LAVASPONGEBLOCK, new Item.Settings().group(VPItemGroups.ALL)));
        Registry.register(Registry.ITEM, new Identifier(modid, "saturated_lava_sponge"), new BlockItem(SATURATEDLAVASPONGEBLOCK, new Item.Settings().group(VPItemGroups.ALL).recipeRemainder(Item.fromBlock(VPBlocks.LAVASPONGEBLOCK))));
        Registry.register(Registry.ITEM, new Identifier(modid, "platinum_ore"), new BlockItem(PLATINUMORE, new Item.Settings().group(VPItemGroups.ALL)));
        Registry.register(Registry.ITEM, new Identifier(modid, "platinum_block"), new BlockItem(PLATINUMBLOCK, new Item.Settings().group(VPItemGroups.ALL)));
        Registry.register(Registry.ITEM, new Identifier(modid, "ruby_block"), new BlockItem(RUBYBLOCK, new Item.Settings().group(VPItemGroups.ALL)));
        Registry.register(Registry.ITEM, new Identifier(modid, "ruby_ore"), new BlockItem(RUBYORE, new Item.Settings().group(VPItemGroups.ALL)));
    }

    public static void initializeTorches() {
        Registry.register(Registry.BLOCK, new Identifier(modid, "green_torch"), new ColorTorchBlock(AbstractBlock.Settings.of(Material.DECORATION).noCollision().breakInstantly().luminance((state) -> 14).sounds(BlockSoundGroup.WOOD), ParticleTypes.FLAME));
        Registry.register(Registry.BLOCK, new Identifier(modid, "green_wall_torch"), new ColorWallTorchBlock(AbstractBlock.Settings.of(Material.DECORATION).noCollision().breakInstantly().luminance((state) -> 14).sounds(BlockSoundGroup.WOOD).dropsLike(Blocks.TORCH), ParticleTypes.FLAME));
    }
}
