package tech.nevets.vplus.misc;

import net.fabricmc.fabric.api.biome.v1.BiomeModifications;
import net.fabricmc.fabric.api.biome.v1.BiomeSelectors;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.BuiltinRegistries;
import net.minecraft.util.registry.Registry;
import net.minecraft.util.registry.RegistryEntry;
import net.minecraft.util.registry.RegistryKey;
import net.minecraft.world.gen.GenerationStep;
import net.minecraft.world.gen.YOffset;
import net.minecraft.world.gen.feature.*;
import net.minecraft.world.gen.placementmodifier.CountPlacementModifier;
import net.minecraft.world.gen.placementmodifier.HeightRangePlacementModifier;
import net.minecraft.world.gen.placementmodifier.SquarePlacementModifier;
import tech.nevets.vplus.blocks.VPBlocks;

import java.util.Arrays;

import static tech.nevets.vplus.Main.modid;

public class VPOreGen {

    private static final ConfiguredFeature<?, ?> ORE_PLATINUM_OVERWORLD_CONFIGURED = new ConfiguredFeature<>
            (Feature.ORE, new OreFeatureConfig(
                    OreConfiguredFeatures.BASE_STONE_OVERWORLD,
                    VPBlocks.PLATINUMORE.getDefaultState(),
                    3)); // vein size
    public static PlacedFeature ORE_PLATINUM_OVERWORLD_PLACED = new PlacedFeature(
            RegistryEntry.of(ORE_PLATINUM_OVERWORLD_CONFIGURED),
            Arrays.asList(
            CountPlacementModifier.of(2), // number of veins per chunk
            SquarePlacementModifier.of(),
            HeightRangePlacementModifier.uniform(YOffset.getBottom(), YOffset.fixed(15))
    ));

    private static final ConfiguredFeature<?, ?> ORE_RUBY_OVERWORLD_CONFIGURED = new ConfiguredFeature<>
            (Feature.ORE, new OreFeatureConfig(
                    OreConfiguredFeatures.BASE_STONE_OVERWORLD,
                    VPBlocks.RUBYORE.getDefaultState(),
                    1));
    public static PlacedFeature ORE_RUBY_OVERWORLD_PLACED = new PlacedFeature(
            RegistryEntry.of(ORE_RUBY_OVERWORLD_CONFIGURED),
            Arrays.asList(
            CountPlacementModifier.of(8), // number of veins per chunk
            SquarePlacementModifier.of(),
            HeightRangePlacementModifier.uniform(YOffset.getBottom(), YOffset.fixed(15))
    ));

    public static void vpOres() {
        Registry.register(BuiltinRegistries.CONFIGURED_FEATURE, new Identifier(modid, "platinum_ore"), ORE_PLATINUM_OVERWORLD_CONFIGURED);
        Registry.register(BuiltinRegistries.PLACED_FEATURE, new Identifier(modid, "platinum_ore"), ORE_PLATINUM_OVERWORLD_PLACED);
        BiomeModifications.addFeature(BiomeSelectors.foundInOverworld(), GenerationStep.Feature.UNDERGROUND_ORES, RegistryKey.of(Registry.PLACED_FEATURE_KEY, new Identifier(modid, "platinum_ore")));

        Registry.register(BuiltinRegistries.CONFIGURED_FEATURE, new Identifier(modid, "ruby_ore"), ORE_RUBY_OVERWORLD_CONFIGURED);
        Registry.register(BuiltinRegistries.PLACED_FEATURE, new Identifier(modid, "ruby_ore"), ORE_RUBY_OVERWORLD_PLACED);
        BiomeModifications.addFeature(BiomeSelectors.foundInOverworld(), GenerationStep.Feature.UNDERGROUND_ORES, RegistryKey.of(Registry.PLACED_FEATURE_KEY, new Identifier(modid, "ruby_ore")));
    }
}
